﻿local AddonVersion = "|cFFDE2121 1.0|r"

RaidEasy_AddonName = "RaidEasy"
RaidEasy_AddonColor = "|cFF003CFF"
addonName = ...
RaidEasy = _G[addonName]

local RaidEasyFrame = nil

RaidWarning1 = RaidWarning1 or "WARNING! THERE IS NO RAID WARNING SET!!!";
RaidWarning2 = RaidWarning2 or "I bet you thought this would say the same thing, didn't you? :D";

REstrings = {

["UItitle"] = "RaidEasy 1.0"

}

function RaidEasyReadyCheck()
    DoReadyCheck();
end

function RaidEasyRoleCheck()
    InitiateRolePoll();
end

function RaidEasyTankAssist()
    local raidCount,memberId;
    raidCount = GetNumGroupMembers();
	
    for i=1, raidCount, 1 do
        memberId = string.format("raid%d", i)
        if(UnitGroupRolesAssigned(memberId)=="TANK") then
            PromoteToAssistant(memberId);
        end
    end
end

function RaidEasyToggleRaid()
    local raidState;
    raidState = IsInRaid();
    if(raidState==true) then
        ConvertToParty();
    else
        ConvertToRaid();
    end
end

function RaidEasyAllAssist()
    local raidCount,memberId;
    raidCount = GetNumGroupMembers();
    
    for i=1, raidCount, 1 do
        memberId = string.format("raid%d", i)
        PromoteToAssistant(memberId);
    end
end


function RaidEasy_Print(msg)
	DEFAULT_CHAT_FRAME:AddMessage(RaidEasy_AddonColor .. RaidEasy_AddonName .. "|r " .. tostring(msg))		
end

function RaidEasy_RaidWarn(message)
	SendChatMessage(message, "RAID_WARNING")
end

function RaidEasy_OnLoad(self)
    RaidEasyFrame = self
    RaidEasy_Print(AddonVersion.." |cFF00FF00Loaded |rClick The MiniMap button to Open.")
    --[[RaidEasyFormRaidToggleButton:Disable()
    RaidEasyFormTankAssistButton:Disable()
    RaidEasyFormRoleButton:Disable()
    RaidEasyFormReadyCheckButton:Disable()]]
    self:RegisterEvent("ADDON_LOADED")
    self:RegisterEvent("PARTY_MEMBERS_CHANGED")
end

function RaidEasy_OnEvent(self, event, ...)
    if event == "ADDON_LOADED" then
        return
    --[[elseif event == "PARTY_MEMBERS_CHANGED" then
        if (IsInGroup()) then 
            RaidEasyFormRaidToggleButton:Enable()
            RaidEasyFormTankAssistButton:Enable()
            RaidEasyFormRoleButton:Enable()
            RaidEasyFormReadyCheckButton:Enable()
        else
            RaidEasyFormRaidToggleButton:Disable()
            RaidEasyFormTankAssistButton:Disable()
            RaidEasyFormRoleButton:Disable()
            RaidEasyFormReadyCheckButton:Disable()
        end]]
    end
end

local function ShowOptionValue( name, val )
  local UIvar = _G["RaidEasyOptionsFrame"..name]
  UIvar:SetText( val )
end

function RaidEasyOptions_OnShow()
  ShowOptionValue( "RaidWarning1", RaidWarning1 )
  ShowOptionValue( "RaidWarning2", RaidWarning2 )	
end

function RaidEasyOptions_Save()
  -- if all the string values are empty, something's gone wrong. Don't 
  -- save.
  
  if ((RaidEasyOptionsFrameRaidWarning1:GetText() == "") and
      (RaidEasyOptionsFrameRaidWarning2:GetText() == "")) then
    return
  end
  
  RaidWarning1 = RaidEasyOptionsFrameRaidWarning1:GetText()
  RaidWarning2 = RaidEasyOptionsFrameRaidWarning2:GetText()
  
end

function RaidEasyOptions_OnLoad()
  RaidEasyOptionsFrameTitle:SetText( REstrings.UItitle )
  
  RaidEasyOptionsFrame.name = "Raid Easy 1.0"
  RaidEasyOptionsFrame.okay = function (self) RaidEasyOptions_Save() end
  RaidEasyOptionsFrame.cancel = nil

  InterfaceOptions_AddCategory(RaidEasyOptionsFrame)
end

function RaidEasyOptions_CheckButtonText(self, text, tooltiptext)
  local textobj = _G[self:GetName().."Text"]
  textobj:SetText(text)
  self.tooltipText = tooltiptext
end

--[[function CantHealYouOptions_SaveDefaults()
  CantHealYou_Config.OnlyPartyRaidGuild = toboolean( CantHealYouOptionsOnlyPartyRaidGuild:GetChecked() )
  CantHealYou_Config.Active = toboolean( CantHealYouOptionsActive:GetChecked() )

  CantHealYou_Config.DoOutOfRange = toboolean( CantHealYouOptionsDoOutOfRange:GetChecked() )
  CantHealYou_Config.OutOfRange = CantHealYouOptionsOutOfRange:GetText()

  CantHealYou_Config.DoLineOfSight = toboolean( CantHealYouOptionsDoLineOfSight:GetChecked() )
  CantHealYou_Config.LineOfSight = CantHealYouOptionsLineOfSight:GetText()
  
  CantHealYou_Config.DoInterrupted = toboolean( CantHealYouOptionsDoInterrupted:GetChecked() )
  CantHealYou_Config.Interrupted = CanHealYouOptionsInterrupted:GetText()
  
  CantHealYou_Config.DoLostControl = toboolean( CantHealYouOptionsDoLostControl:GetChecked() )
  CantHealYou_Config.LostControl = CantHealYouOptionsLostControl:GetText()
  CantHealYou_Config.GainedControl = CantHealYouOptionsGainedControl:GetText()

  CantHealYou_Config.DoAuraBounced = toboolean( CantHealYouOptionsDoAuraBounced:GetChecked() )
  CantHealYou_Config.AuraBounced = CantHealYouOptionsAuraBounced:GetText()
  
  CantHealYou_Config.Interval = tonumber(CantHealYouOptionsInterval:GetText())
end

function CantHealYouOptions_LoadDefaults()
  ShowDefaultValue( "OnlyPartyRaidGuild" )
  ShowDefaultValue( "Active" )
  ShowDefaultValue( "DoOutOfRange" )
  ShowDefaultValue( "OutOfRange" )
  ShowDefaultValue( "DoLineOfSight" )
  ShowDefaultValue( "LineOfSight" )
  ShowDefaultValue( "DoInterrupted" )
  ShowDefaultValue( "Interrupted" )
  ShowDefaultValue( "DoLostControl" )
  ShowDefaultValue( "LostControl" )
  ShowDefaultValue( "GainedControl" )
  ShowDefaultValue( "DoAuraBounced" )
  ShowDefaultValue( "AuraBounced" )
  ShowDefaultValue( "Interval" )
end
]]